import { SchemaObject, ValidateFunction } from "ajv";
import type { NextApiRequest, NextApiResponse } from "next";
import type { AnySchema } from "../types/schema";
import { OrPromise, ValueOf } from "./utils";
type Serializer = (doc: string) => any;
export interface Validator {
    query?: ValidateFunction;
    body?: ValidateFunction;
    responseSerializers?: Map<string, Serializer>;
}
interface SchemaFileContent {
    models: Record<string, SchemaObject>;
    routes: Record<string, SchemaObject>;
}
export declare function createValidatorsFromSchema(schemas: SchemaFileContent): Map<string, Validator>;
export declare function route<S extends AnySchema>(schemaName: string, handler: (req: Omit<NextApiRequest, "body"> & {
    query: S["query"];
    body: S["body"];
}, res: NextApiResponse<ValueOf<S["responses"]>>) => OrPromise<Partial<S["responses"]> | void>): typeof handler;
export {};
